#include <clipboard/clipboard_plugin.h>
#include <flutter/method-channel.h>
#include <sys/utsname.h>
#include <QClipboard>
#include <QApplication>
#include <QCoreApplication>

void ClipboardPlugin::RegisterWithRegistrar(PluginRegistrar &registrar)
{
    registrar.RegisterMethodChannel("clipboard",
                                    MethodCodecType::Standard,
                                    [this](const MethodCall &call) { this->onMethodCall(call); });
}

void ClipboardPlugin::onMethodCall(const MethodCall &call)
{
    const auto &method = call.GetMethod();

    if (method == "setText") {
        onSetText(call);
        return;
    }

    unimplemented(call);
}

void ClipboardPlugin::onSetText(const MethodCall &call)
{
    auto value = call.GetArgument<Encodable::String>("value");

    if(QClipboard* c = QApplication::clipboard() ) {
        c->setText(value.c_str());
    }

    call.SendSuccessResponse(nullptr);
}

void ClipboardPlugin::unimplemented(const MethodCall &call)
{
    call.SendSuccessResponse(nullptr);
}
