import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';

import 'clipboard_platform_interface.dart';

/// An implementation of [ClipboardPlatform] that uses method channels.
class MethodChannelClipboard extends ClipboardPlatform {
  /// The method channel used to interact with the native platform.
  @visibleForTesting
  final methodChannel = const MethodChannel('clipboard');

  @override
  Future<void> setText(String value) async {
    if (TargetPlatform.aurora == defaultTargetPlatform) {
      return methodChannel.invokeMethod<void>('setText', { 'value': value });
    }

    return Clipboard.setData(ClipboardData(text: value));
  }
}
