import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'clipboard_method_channel.dart';

abstract class ClipboardPlatform extends PlatformInterface {
  /// Constructs a ClipboardPlatform.
  ClipboardPlatform() : super(token: _token);

  static final Object _token = Object();

  static ClipboardPlatform _instance = MethodChannelClipboard();

  /// The default instance of [ClipboardPlatform] to use.
  ///
  /// Defaults to [MethodChannelClipboard].
  static ClipboardPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [ClipboardPlatform] when
  /// they register themselves.
  static set instance(ClipboardPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<void> setText(String value) {
    throw UnimplementedError('setText() has not been implemented.');
  }
}
